#include "debug.h"

bool Debug::sm_enable = false;

void Debug::Enable(bool enable)
{
	sm_enable = enable;
}

void Debug::Output(const char* type, const char* fmt, va_list argp)
{
  if (sm_enable) {
	fprintf(stderr, "%s: ", type);
	vfprintf(stderr, fmt, argp);
	fprintf(stderr, "\r\n");
	va_end(argp);
  }
}


void Debug::Error(const char* fmt, ...)
{
  if (sm_enable) {
	va_list argp;
	va_start(argp, fmt);
	Output("ERROR", fmt, argp);
  }
}

void Debug::Warning(const char* fmt, ...)
{
  if (sm_enable) {
	va_list argp;
	va_start(argp, fmt);
	Output("WARNING", fmt, argp);
  }
}

void Debug::Message(const char* fmt, ...)
{
  if (sm_enable) {
	va_list argp;
	va_start(argp, fmt);
	Output("DEBUG", fmt, argp);
  }
}
