#include "fileio.h"

FileIO* FileIO::OpenToRead(const std::string & filename)
{
  if(filename == "") return NULL;

  FILE* fh = NULL;
  if((fh = fopen(filename.c_str(), "r")) == NULL) return NULL;

  return new FileIO(fh);
}

FileIO* FileIO::OpenToWrite(const std::string & filename)
{
  if(filename == "") return NULL;

  FILE* fh = NULL;
  if((fh = fopen(filename.c_str(), "w")) == NULL) return NULL;

  return new FileIO(fh, true);
}

dword FileIO::Read(byte* pbdata, dword cbdata)
{
  if(m_writeaccess) 
    return 0;
  if(pbdata == NULL || m_filehandle == NULL) 
    return 0;

  dword len = 0;
  len = fread(pbdata, sizeof(byte), cbdata, m_filehandle);

  return len;
}

dword FileIO::Write(byte* pbdata, dword cbdata)
{
  if(!m_writeaccess) return 0;
  if(pbdata == NULL || m_filehandle == NULL) return 0;

  dword len = 0;
  len = fwrite(pbdata, sizeof(byte), cbdata, m_filehandle);

  return len;
}

bool FileIO::Copy (FileIO *source)
{
	if (!m_writeaccess || !source) return false;

	if (!source->Writeable())
	{
		byte buffer[1024] = {0};
				
		while(int i = source->Read (buffer, sizeof (buffer))) this->Write (buffer, i);

		return true;
	}

	return false;
}

void FileIO::GetCompleteFile (std::string &cf) {
  byte* buffer = (byte*) malloc (1024 * sizeof (char));
				
  while(int i = this->Read (buffer, 1024)) {
    cf.append ((char*)buffer, i);
  }
  if (buffer) 
    free (buffer);
}


bool FileIO::Writeable () {
  return m_writeaccess;
}

void FileIO::Close()
{
  if(m_filehandle)
    {
      fclose(m_filehandle);
      m_filehandle = NULL;
    }
}

void FileIO::Reset()
{
  if(m_filehandle) fseek(m_filehandle, 0, SEEK_SET);
}




FileIO::FileIO(FILE* filehandle, bool bWriteAccess) : m_filehandle(filehandle), m_writeaccess(bWriteAccess)
{
}

FileIO::~FileIO()
{
  Close();
}

FileIO::FileIO()
{
}


FileIO::FileIO(FileIO & fr)
{
}
