#ifndef __CLASS_FILEIO__
#define __CLASS_FILEIO__

#include "plattform.h"
#include <stdio.h>
#include <string>

#include "defines.h"

//! Die Klasse FileIO stellt die Funktionalitt fr das Lesen und Schreiben von Dateien zur Verfgung. 
class FileIO
{
 public:
  //! zum Lesen ffnen
  static FileIO* OpenToRead(const std::string &);
  //! zum Schreiben ffnen
  static FileIO* OpenToWrite(const std::string &);
  ~FileIO();

  //! lesen
  dword Read(byte*, dword);
  //! schreiben
  dword Write(byte*, dword);

  //! kopiert die Dateien komplett
  bool Copy (FileIO *);

  //! true wenn datei zum Schreiben geffnet ist
  bool Writeable ();

  //! setzt Positionszeiger des Files zurck an den Anfang
  void Reset();
  //! datei schliessen
  void Close();

  //! gibt den kompletten Dateiinhalt als string zurck
  void GetCompleteFile (std::string &cf);

 private:
  FileIO(FILE*, bool bWriteAccess = false);
  FileIO();               //nur um den default zu berschreiben; ntig fr gcc
  FileIO(FileIO &);       //nur um den default zu berschreiben; ntig fr gcc

 protected:
  FILE*   m_filehandle;
  bool	m_writeaccess;
};


#endif
