#ifndef __CLASS_INIFILEPARSER__
#define __CLASS_INIFILEPARSER__

#include "plattform.h"
#include "defines.h"
#include "confobject.h"
#include "fileio.h"

#include <string>
#include <iostream>

enum { STATE_NULL = 0, STATE_SECTION, STATE_SUBSECTION, STATE_DATA_KEY, STATE_DATA_VALUE };
enum { S_OK = 0, E_KEY, E_VALUE, E_SUBSECTION, E_SECTION };


//! Die Klasse INIFileParser ldt die Konfigurationsdatei und stellt sie in einem leicht verarbeitbaren Format zur Verfgung.
class INIFileParser
{
    public:
        //! parst das bergebene File
        static ConfObject* Parse(const std::string &);
	//! parst das bergebene File
        static ConfObject* Parse(FileIO* configname);

    private:
    	INIFileParser();
        INIFileParser(FileIO* fileio);
        INIFileParser(INIFileParser &);
        ~INIFileParser();

        ConfObject*	Parse();
        void ParsePrepareNew();
        void ParseSection(byte b);
        void ParseSubSection(byte b);
        void ParseDataKey(byte b);
        void ParseDataValue(byte b);
        void Insert();
        void InsertMulti();

        void Error(dword errnum);

    protected:
    	dword			m_state;
    	FileIO*			m_fileio;
    	ConfObject*		m_confobj;
    	std::string		m_section;
    	std::string		m_subsection;
    	std::string		m_key;
    	std::string		m_value;
    	dword 			m_linecount;
};


#endif
