#include "wml_interface.h"
#include "debug.h"
#include "Ttos.h"
#include "fileio.h"
#include "sqltools.h"
#include "plattform.h"

#include <iostream>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <assert.h>
#include <string.h>
//#include <sqlplus.hh>

#include <MySQLaux/Database.h>


/* web-version mit mysql-untersttzung */

//wenn nicht definiert gibt das Prog keine Statusmeldungen aus 
//#define CONSOLE

const bool storedb = 1;
const std::string user = "www-dummy";
const std::string passwd = "sqltest";
const std::string host = "localhost";
const std::string db = "wmlgen";
//const std::string mypath = "/share/www/wml/cgi-bin/";
const std::string mypath = "./";


int main(int argc, char **argv)
{
  //srand(time(0));
  Debug::Enable(false);
  std::string config;
  double seed = 0;
  bool fromdb = false;
  bool loadconfig = false;

  if (argc == 1)
    {
      config = mypath + std::string("web.cfg");

    }
  if (argc == 3)
    {
      if (std::string (argv[1]) == "-t") {
	fromdb = true;
	loadconfig = true;
      }
      else if (std::string (argv[1]) == "-w") {
	fromdb = true;
	loadconfig = false;
      }
    }
  if (argc >= 4)
    {
      exit (-1);
    }


#ifdef CONSOLE
  std::cout << " Erstelle WML_Interface.\n";
#endif
  WML_Interface* wml = NULL;

  struct timeval tv;
  gettimeofday (&tv,NULL);
  std::string timestamp = "_" + Ttos<long>((long)tv.tv_sec) + "_" + Ttos<long>((long)tv.tv_usec);

  if (fromdb) {
    //daten aus db laden
    if (loadconfig) {
      //cfg und seed laden
    }
    else {
      //wml file laden und zurckgeben

    }
  }

  seed = tv.tv_sec ^ tv.tv_usec;
  //wml interface anlegen
  wml = new WML_Interface(config, seed);


  /* *******************************
     hier wird Dokument erzeugt
     ******************************* */

  wml->setTimestamp (timestamp);

  wml->build_tree();
  std::string wmldoc = wml->output();



  /* *******************************
     hier wird Dokument gespeichert
     ******************************* */

  if (storedb) { //in db speichern

#ifdef CONSOLE
    std::cout << " Speichere Dokument in DB.\n";
#endif


    //MySQLaux

    //zu db connecten
    wmlgenDB mydb (host, user, passwd, db);
    if (!mydb.isConnected())
      exit (-1);

    //query-string bauen
    std::string ewmldoc;
    std::string myconfig;
    std::string econfig;
    mydb.escapeString (wmldoc, ewmldoc);
    FileIO* configFile = FileIO::OpenToRead (config);
    configFile->GetCompleteFile (myconfig);
    if (configFile) 
      delete configFile;
    mydb.escapeString (myconfig, econfig);

    //kommentar erzeugen
    struct tm *mytm = localtime (&tv.tv_sec);
    std::string kommentar = "erzeugt am " + Ttos<int>(mytm->tm_mday) + "." + Ttos<int>(mytm->tm_mon)
      + " um " + Ttos<int>(mytm->tm_hour) + ":" + Ttos<int>(mytm->tm_min) + ":" + Ttos<int>(mytm->tm_sec);

    //tabelle : timestamp | cfg | seed | wml | kommentar
    std::string insertq = "insert into dokumente values ('" 
      + timestamp + "', '" + econfig + "', " + Ttos<double>(seed) + ",'" + ewmldoc + "','" + kommentar + "')";

    // query ausfhren
    MySQLaux::Table *mytable = mydb.doQuery (insertq);
    if (!mytable) {
      exit (-1);
    }
#ifdef CONSOLE
    mydb.printQuery ("select * from wmlgen.dokumente");
#endif

  }

  std::cout << timestamp  << std::endl;



  return 0;
}
