#include "pcdata.h"
#include "generator.h"
#include "Ttos.h"

PCData::PCData( std::string _encoding, Element* _parent, int _average_length_string, int _max_deviation_string)
{
	m_parent = _parent;
	encoding = _encoding;	
	m_tagname = "pcdata";
	average_length_string = _average_length_string;
	max_deviation_string = _max_deviation_string;
}

std::string PCData::ToString (  )
{
	std::string output = "";
	int char_cnt = 0;
	if ( encoding == "us-ascii" )  // US-ASCII hat insgesamt 128 Zeichen (0 - 127)
	{
		char_cnt = 0x0000007f;
	}
	else if ( encoding == "iso-8859-1" )  // ISO-8859-1 hat 256 Zeichen (0 - 255)
	{
		char_cnt = 0x000000ff;
	}
	else if ( encoding == "ucs-4" ) // 4-Byte (32 bit)  2^31 moegliche Zeichen
	{
		char_cnt = 0x7fffffff;
	}
	else if ( encoding == "utf-8" ) // Unicode-Kodierung mit 1 bis 6 bytes, ebenfalls 2^31 moegl. Zeichen
	{
		char_cnt = 0x7fffffff;
	}

	if ( char_cnt == 0 )
	{
		//default: us-ascii
		char_cnt = 0x0000007f;
	}

	int cnt = average_length_string + (int)(Generator::rnd()*max_deviation_string);
	
	//std::cout << "Anzahl Zeichen: "<< cnt << "\n";
	
	std::string tmp = "";
	for (int i = 0; i < cnt; ++i)
	{
		output += "&#";
		
		output += Ttos<int>( getValidChar(char_cnt) );
		output += ";";
	}

	output += "\n";
	return output;
}

int PCData::getValidChar( int max_char )
{
	int ch = (int)(Generator::rnd() * max_char);
	while (!(     ((ch>32) && (ch<55295)) || ((ch>57344) && (65533)) || ((ch>65536) && (ch<1114111)) ))
		ch = (int)(Generator::rnd() * max_char);
	return ch;
}

void PCData::addChild ( Element* new_elem )
{
	// DO NOTHING HERE !
	// PCDATA HAS NO CHILDS
}

std::map< std::string, bool > PCData::get_parents( )
{
	// DO NOTHING HERE !
	// PCDATA HAS NO CHILDS
	std::map< std::string, bool > res;
	return res;
}
