#ifndef PCDATA_H
#define PCDATA_H

#include "plattform.h"
#include "element.h"
#include <string>

//! Die Klasse PCDATA reprsentiert den Typ PCDATA. 
/*! Bei Text diesen Typs mssen Zeichen wie ``\<'', ``\>'', ``\&'' mit dem 
  entsprechenden XML-Code umschrieben werden, z.B. ``\<'' = \&lt;. */
class PCData: public Element
{
  // Operations
  public:
  PCData( std::string encoding, Element* _parent, int average_length_string, int max_deviation_string);
  std::string ToString (  );
  void addChild ( Element* new_elem );
  std::map< std::string, bool > get_parents( );
  private:
  int getValidChar( int max_char );

  // Associations
  // Attributes
  private:
  int average_length_string;
  int max_deviation_string;
  std::string encoding;
};

#endif
