#include "plattform.h"
#include "Ttos.h"

#include <stdio.h>


int ptolower(int a)
{
    return ((a < 'A') ? a : (( a > 'Z') ? a : (a + 32)));
}

int ptoupper(int a)
{
    return ((a < 'a') ? a : ((a > 'z') ? a : (a - 32)));
}

int pstrcmpi(char* s1, char* s2)
{
	char* p1 = s1;
	char* p2 = s2;

	if(p1 == p2) return 0;
	else if(p1 == 0) return -1;
	else if(p2 == 0) return  1;

	while(*p1 && *p2)
	{
		int a = ptolower(*p1++);
		int b = ptolower(*p2++);
		if(a < b) return 1;
		else if(a > b) return -1;
	}

	if(*p1) return -1;
	else if(*p2) return 1;

	return 0;
}


std::string BuildTimestamp()
{
	std::string ts = "not used";

#	if defined WIN32
		time_t tm;
		time(&tm);
		ts = Ttos<time_t>(tm);
#	else
		struct timeval tv;
  		gettimeofday (&tv, NULL);
  		ts = "_" + Ttos<long>(tv.tv_sec) + "_" + Ttos<long>(tv.tv_usec);
#	endif

	return ts;
}









