#include "tag.h"
//#include "ttos.h"
#include <iostream>

Tag::Tag ( std::string name, Element* parent, std::list< std::string > attrlist, std::map< std::string, bool > parents, int spaces, bool emptytag )
: m_parents(parents)
{
	m_attributes = attrlist;
	m_parent = parent;
	m_emptytag = emptytag;
	prepared = true;
	m_children.clear();
	m_tagname = name;
	m_spaces = spaces;
	//std::cout << "Spaces des Tag " << m_tagname << " im grossen Konstruktor: " << m_spaces << "\n";
}

Tag::Tag ( std::string name, Element* parent, std::map< std::string, bool > parents, int spaces, bool emptytag )
: m_parents(parents), prepared(false)
{
	m_emptytag = emptytag;
	m_tagname = name;
	m_parent = parent; 
	m_children.clear();
	m_spaces = spaces;
	//std::cout << "Spaces des Tag " << m_tagname << " im kleinen Konstruktor: " << m_spaces << "\n";
}

void Tag::addAttributes( std::list< std::string > attrlist )
{
	m_attributes = attrlist;
}

Tag::~Tag (  )
{
}

std::string Tag::ToString (  )
{
	
	std::string result = "";
	int i;
	if (!m_emptytag)
	{				
		for (i = 0; i< m_spaces; ++i) result+=" ";		
		result += "<" + m_tagname + process_attributes() + ">\n";		
		result += process_children();
		for (i = 0; i< m_spaces; ++i) result+=" ";
		result += "</" + m_tagname + ">\n";		
	}
	else
	{		
		for (i = 0; i< m_spaces; ++i) result+=" ";
		result+= "<";
		result+= m_tagname;		
		result+= process_attributes();		
		result+= "/>\n";		
	}		

	return result;
}

std::string Tag::process_attributes (  )
{			
	std::string result = "";
	
	std::list< std::string >::iterator iter = m_attributes.begin();
	for (; iter != m_attributes.end() ; ++iter )
	{
		result += " ";
		result += *iter;
	}	
	
	return result;

}

int Tag::get_spaces (  )
{
	return 0;
}

std::map< std::string, bool > Tag::get_parents( )
{
	std::map< std::string, bool > res;
	res = m_parents;
	res[m_tagname] = true;

	return res;
}

void Tag::addChild ( Element* new_elem )
{
	m_children.push_back( new_elem );
}

std::string Tag::process_children (  )
{	
	std::string result = "";
	std::list< Element* >::iterator iter = m_children.begin();
	while(iter != m_children.end())	
	{
		result += (*iter)->ToString();
		++iter;
	}
	return result;
}

