#ifndef TAG_H
#define TAG_H

#include "plattform.h"
#include "element.h"
#include <list>
#include <string>
#include <map>

//! Die Klasse Tag ist direkt von Element abgeleitet und reprsentiert ein Strukturelement innerhalb des erzeugten Dokuments.
class Tag: public Element
{
  // Associations
  // Attributes
 public:
 private:
  std::list< Element* > m_children;
  std::list< std::string > m_attributes;
  std::map< std::string, bool > m_parents;
  bool m_emptytag;
  bool prepared;

  // Operations
 public:
  Tag ( std::string name, Element* parent, std::list< std::string > attrlist, 
	std::map< std::string, bool > parents, int spaces, bool emptytag  = false );
	
  Tag ( std::string name, Element* parent, std::map< std::string, bool > parents, 
	int spaces, bool emptytag  = false );
  void addAttributes( std::list< std::string > attrlist );

  ~Tag (  );
  std::string  ToString (  );
  std::string process_attributes (  );
  int get_spaces (  );
  std::map< std::string, bool > get_parents( );
  void addChild ( Element* new_elem );
  std::string process_children (  );
};

#endif
