#include "wml_interface.h"
#include <iostream>
#include <string>
#include <time.h>

#include "fileio.h"

WML_Interface::WML_Interface ( std::string configname  )

{
  config = FileIO::OpenToRead( configname );

  //seed bestimmen
  time((long*)&seed);
}

WML_Interface::WML_Interface (std::string configname, dword _seed) : seed(_seed) {
  config = FileIO::OpenToRead( configname );
}

WML_Interface::~WML_Interface ( )
{
}

std::string WML_Interface::output ( )
{
	std::string data = wml_tree->ToString();
	return data;
}

WML_Tree* WML_Interface::build_tree (  )
{
  generator = Generator::CreateInterface(config, seed);
  generator->setTimestamp (timestamp);
  wml_tree = generator->generateTree();

  return wml_tree;
}

dword WML_Interface::get_seed () {
  return seed;
}


void WML_Interface::setTimestamp (std::string ts ) {
  timestamp = ts;
}

bool WML_Interface::IsReady() const
{
	return config != NULL;
}
