#include <cppunit/TestCase.h>
#include <cppunit/TestSuite.h>
#include <cppunit/TestCaller.h>

#include <unistd.h>
#include <iostream.h>

#include "wml_interface.h"


class WithoutConfigTest : public CppUnit::TestCase {
 public: 
  WithoutConfigTest( std::string name ) : CppUnit::TestCase( name ) {}

  void runTest() {
    WML_Interface* wml = new WML_Interface("default.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    if (wml) delete wml;
  }
  static CppUnit::Test *suite() {
    CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "WithoutConfigTest" );
    suiteOfTests->addTest( new WithoutConfigTest("WithoutConfigTest") );
    return suiteOfTests;
  }
};


class WithConfig31xTest : public CppUnit::TestCase {
 public: 
  WithConfig31xTest( std::string name ) : CppUnit::TestCase( name ) {}

  void runTest() {
    FileIO* of = NULL;
    std::string doc = ""; 
    WML_Interface* wml = new WML_Interface("configTest311.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest311.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) 
      delete wml;  
    wml = new WML_Interface("configTest312.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest312.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) 
      delete wml;
    wml = new WML_Interface("configTest313.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest313.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) 
      delete wml;
    wml = new WML_Interface("configTest314.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest314.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) 
      delete wml;
  }
  
  static CppUnit::Test *suite() {
    CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "WithConfig31xTest" );
    suiteOfTests->addTest( new WithConfig31xTest("WithConfig31xTest") );
    return suiteOfTests;
  }
};


class WithConfig320Test : public CppUnit::TestCase {
 public: 
  WithConfig320Test( std::string name ) : CppUnit::TestCase( name ) {}

  void runTest() {
    FileIO* of = NULL;
    std::string doc = ""; 
    WML_Interface* wml = new WML_Interface("configTest320.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest320.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) 
      delete wml;
  }
  
  static CppUnit::Test *suite() {
    CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "WithConfig320Test" );
    suiteOfTests->addTest( new WithConfig320Test("WithConfig320Test") );
    return suiteOfTests;
  }
};


class WithConfig330Test : public CppUnit::TestCase {
 public: 
  WithConfig330Test( std::string name ) : CppUnit::TestCase( name ) {}

  void runTest() {
    FileIO* of = NULL;
    std::string doc = ""; 
    WML_Interface* wml = new WML_Interface("configTest330.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest330.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) 
      delete wml;
  }
  
  static CppUnit::Test *suite() {
    CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "WithConfig330Test" );
    suiteOfTests->addTest( new WithConfig330Test("WithConfig330Test") );
    return suiteOfTests;
  }
};

class WithConfig340Test : public CppUnit::TestCase {
 public: 
  WithConfig340Test( std::string name ) : CppUnit::TestCase( name ) {}

  void runTest() {
    FileIO* of = NULL;
    std::string doc = ""; 
    WML_Interface* wml = new WML_Interface("configTest340.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest340.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) delete wml;
  }
  
  static CppUnit::Test *suite() {
    CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "WithConfig340Test" );
    suiteOfTests->addTest( new WithConfig340Test("WithConfig340Test") );
    return suiteOfTests;
  }
};

class WithConfig350Test : public CppUnit::TestCase {
 public: 
  WithConfig350Test( std::string name ) : CppUnit::TestCase( name ) {}

  void runTest() {
    FileIO* of = NULL;
    std::string doc = ""; 
    WML_Interface* wml = new WML_Interface("configTest350.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest350.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) delete wml;
  }
  
  static CppUnit::Test *suite() {
    CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "WithConfig350Test" );
    suiteOfTests->addTest( new WithConfig350Test("WithConfig350Test") );
    return suiteOfTests;
  }
};

class WithConfig360Test : public CppUnit::TestCase {
 public: 
  WithConfig360Test( std::string name ) : CppUnit::TestCase( name ) {}

  void runTest() {
    FileIO* of = NULL;
    std::string doc = ""; 
    WML_Interface* wml = new WML_Interface("configTest360.cfg");
    wml->build_tree();
    CPPUNIT_ASSERT ( wml->output() != "");
    doc = wml->output();
    if ((of = FileIO::OpenToWrite("outputTest360.wml")))	{
    	of->Write((byte*) doc.c_str(), (dword) doc.size());
    	delete of;
   	}
    if (wml) delete wml;
  }
  
  static CppUnit::Test *suite() {
    CppUnit::TestSuite *suiteOfTests = new CppUnit::TestSuite( "WithConfig360Test" );
    suiteOfTests->addTest( new WithConfig360Test("WithConfig360Test") );
    return suiteOfTests;
  }
};
